/*  DICTFIX.C                          */

/*  Use only words out of a dictionary that are usable for passwords  */
/*  For those who don't want to wait around */
 
/*  Written by "The Rack" of the Hellfire Club  */

/*  Version 1.1.0 relase on 10/14/91  */ 

/*  Compile using ansi or traditional C with 'cc -o dictfix dictfix.c' */

#define BUFFER 70     /* Place to save it while loading */
#define MAXWORD 10    /* The point where the computer cries uncle! */
#define MINWORD 5     /* Miminum allowable by machine */

#include <stdio.h>

main(int argc, char *argv[])
{
   char   c, letter[MAXWORD];
   long   kept, left;
   int    i, x; 
   FILE   *ifp, *ofp;

   kept = 0;
   left = 0;
   if (argc != 3) {
      printf("\n%s%s%s\n\n%s\n\n",
         "Usage: ", argv[0], " indict outdict",
         "For scraping out unusable data for encrypting/comparing.");
    exit(1);
    }
   printf(" ##################################################################\n");
   printf("# THE DICTIONARY FIXER -- Written by The RACK of the Hellfire Club #\n");
   printf("# Release 1.1.0, 11/14/91. For scraping unusable words for hacking #\n";
   printf(" ##################################################################\n");
  
  
   ifp = fopen(argv[1], "r");
   ofp = fopen(argv[2], "w");
   for (i=0; i <= BUFFER; i++) letter[i]=0; 
   i = 0;
   while ((c = getc(ifp)) != EOF)
      {
      if (c == '\n') {
	 if (i >= MINWORD ) { 
            if ( i < MAXWORD ) { 
            for (x=0; x < i; x++) putc(letter[x],ofp); 
            putc('\n',ofp);
            kept++;
            }
            else left++;
            i = 0;
            }
         else {
            left++; 
            i = 0;
            }
         }
      else
         {
         letter[i]=c;
         i++;
         }
      }   
   putc('\n', ofp);
   printf("%s%d\n%s%d\n\n","#> Total words kept in new dictionary: ",kept,
          "#> Total words discarded: ",left); 
   fclose(ofp);
   fclose(ifp);
   exit(1);
}
